#include "intpointsc.h"
#include "globalc.h"
#include <string.h>

intpointsc::intpointsc ()
{
  tm = (mattypec) 0;  idm=0;
  av=NULL;  pv=NULL;  grad=NULL;  fluxes=NULL;
  stresses=NULL;
  strains=NULL;
  nmcomp=0; mssst = (strastrestate) 0;
}

intpointsc::~intpointsc (void)
{
  delete [] strains;  delete [] stresses;
  delete [] av;  delete [] pv;
  for(long i=0; i<Tp->ntm; i++)
  {
    delete [] grad[i];
    delete [] fluxes[i];
  }
  delete [] grad;
  delete [] fluxes;
}

/**
   function allocates arrays on integration points
   
   JK, 30.10.2004
*/
void intpointsc::alloc ()
{
  long ntm;
  
  //  number of transported media
  ntm = Tp->ntm;
  
  strains = new double [nmcomp];
  stresses = new double [nmcomp];
  
  av = new double [ntm];
  pv = new double [ntm];
}
